// HUD stuffing.
local iswindows = false
local fader = 0
local mpeg = 3
local winglow = 0
local tokenpresent = false
local location = 0
local sscheck = 0
local mspaint = CV_FindVar("canyon.mid")
local totitle = false	
local tocredits = false
local toend = false
local coop = false
local mapname = "aeiou"
local act = "act"
local docustomintro = true
local actcolor = 0

local function customintro(player, arg)
	if arg
		arg = arg:lower()
		if arg == "0" or arg == "disable" or arg == "false"
			docustomintro = false
			player.wintro = false
			CONS_Printf(player, "Custom title card disabled.")
			S_StartSound(nil, sfx_uihmsn, consoleplayer)
		elseif arg == "1" or arg == "enable" or arg == "true"
			docustomintro = true
			player.wintro = true
			CONS_Printf(player, "Custom title card enabled.")
			S_StartSound(nil, sfx_uihmsn, consoleplayer)
		else
			CONS_Printf(player, "If true, a custom title card will be displayed. Currently " + docustomintro + ".")
		end
	end
end

COM_AddCommand("winintro", function(player, arg)
	if player.wintro == nil then player.wintro = true end
	if arg then customintro(player, arg)
	else CONS_Printf(player, "If true, a custom title card will be displayed. Currently " + docustomintro + ".")
	end
end)

// Map shenanigans.
addHook("MapLoad", function(gamemap)
	location = mapheaderinfo[gamemap].nextlevel
	mapname = mapheaderinfo[gamemap].lvlttl
	act = mapheaderinfo[gamemap].actnum
	if mapheaderinfo[gamemap].bonustype == 2 or mapheaderinfo[gamemap].bonustype == 1 then actcolor = 20480
	else actcolor = 0 end
	if location == 1100 then totitle = true else totitle = false end
	if location == 1102 then tocredits = true else tocredits = false end
	if location == 1103 then toend = true else toend = false end
	if (G_IsSpecialStage(gamemap)) then
		sscheck = true
		actcolor = 8192
	else
		sscheck = false
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "windows" then
		player.iswindows = true
	else
		player.iswindows = false
	end
	if G_PlatformGametype() then coop = true else coop = false end
end)

addHook("MusicChange", function(oldname, newname)
	if newname == "_creds" and mspaint.value != 0 and consoleplayer.iswindows then
		return "XPOOBE"
	end
end)

local function WinTitle(v)
	v.draw(4, 4, v.cachePatch("WINRUN"), V_SNAPTOTOP|V_SNAPTOLEFT|V_MEDSCALEPATCH|V_HUDTRANSHALF)
	v.drawString(24, 8, ("Windows initialized."), V_SNAPTOTOP|V_SNAPTOLEFT|V_SKYMAP|V_MEDSCALEPATCH|V_HUDTRANSHALF, "thin")
end

local function WinHUD(v, player, camera)
	if player.mo and player.mo.valid and player.mo.skin == "windows" then
		if player.winpopup != nil and player.xpcooldown != nil then
			local winready = v.cachePatch("WINREADY")
			local winwarn = v.cachePatch("WINWARN")
			local kgrow = v.cachePatch("KGROW")
			local winnotready = v.cachePatch("WINNOT")
			local directx = v.cachePatch("WINDX")
			local directxbw = v.cachePatch("WINDX1")
			local spiking = v.cachePatch("WINBUST")
			local startbtn = v.cachePatch("WINSTART")
			local growth = CV_FindVar("kartgrow")
			local directxtoggle = CV_FindVar("DirectX")
			local kflash = leveltime%2
			local fadetime = leveltime%4
			local run = (15*TICRATE - player.winpopup) / TICRATE
			local clocking = (60*TICRATE - player.xpcooldown) / TICRATE
			local growthtimer = (player.powers[pw_sneakers] / TICRATE)
			if player.powers[pw_super] != 0 and (player.hyper == nil or player.hyper.capable == false) then
				if not player.xpready then
					v.draw(17, 141, winnotready, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					v.drawString(37, 145, (clocking), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_GRAYMAP, "thin")
				elseif player.xpready then
					v.draw(17, 141, winready, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					v.drawString(37, 145, ("Ready"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_GREENMAP, "thin")
				end
			elseif player.powers[pw_super] != 0 and (player.hyper and player.hyper.capable == true) then
				if player.canxpblast then
					if not player.xpready then
						v.draw(17, 141, winnotready, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
						v.drawString(37, 145, (clocking), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_GRAYMAP, "thin")
					elseif player.xpready then
						if player.hyper and player.hyper.capable == true then
							v.draw(17, 141, winwarn, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
							v.drawString(37, 145, ("Ready"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_YELLOWMAP, "thin")
						end
					end
				else
					v.draw(17, 141, winnotready, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					v.drawString(37, 145, "OFF", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_REDMAP, "thin")
				end
			end
			if growth.value == 1 and player.powers[pw_sneakers] != 0 then
				if kflash == 1 then
					v.draw(292, 10, kgrow, V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
				end
				if player.powers[pw_sneakers] >= 3*TICRATE then
					v.drawString(300, 16, growthtimer, V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANSDOUBLE|V_BLUEMAP, "center")
				elseif player.powers[pw_sneakers] < 3*TICRATE then
					if kflash == 1 then v.drawString(300, 16, growthtimer, V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANSDOUBLE|V_REDMAP, "center") end
				end
			end
			if directxtoggle.value == 1 then
				if player.dxready then
					v.draw(16, 158, directx, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					v.drawString(37, 162, ("Ready"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_YELLOWMAP, "thin")
				else
					v.draw(16, 158, directxbw, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					v.drawString(37, 162, run, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_GRAYMAP, "thin")
				end
			end
			if player.exiting == 0 then
				if (player.powers[pw_super] != 0 or player.powers[pw_invulnerability] != 0) then
					v.draw(16, 125, spiking, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				elseif player.cpanel > 0 then
					v.draw(16, 125, spiking, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				elseif player.speed > 16*FRACUNIT and player.pflags & (PF_SPINNING) then
					v.draw(16, 125, spiking, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				elseif player.speed > 35*FRACUNIT then
					v.draw(16, 125, spiking, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				end
				fader = 0
			elseif player.exiting >= 1 then
				if not (sscheck) then
					if (fadetime == 1 and fader < 31) then fader = $ + 1 end
					v.fadeScreen(65280, fader)
					if fader == 31 then v.drawFill() end
				end
				if token > 0 and not All7Emeralds(emeralds) then tokenpresent = true 
				else tokenpresent = false end
			end
		end
	end
end

local function WinInter(v)
	if not consoleplayer.iswindows then return end
	local bar = v.cachePatch("WINBAR")
	local flash1 = v.cachePatch("WINBAR1")
	local flash2 = v.cachePatch("WINBAR2")
	local flash3 = v.cachePatch("WINBAR3")
	local flash4 = v.cachePatch("WINBAR4")
	local flash5 = v.cachePatch("WINBAR5")
	local flash6 = v.cachePatch("WINBAR6")
	local flash7 = v.cachePatch("WINBAR7")
	local winbg1 = v.cachePatch("WINCLR1")
	local winbg2 = v.cachePatch("WINCLR2")
	v.drawFill()
	if mpeg > 0 then mpeg = $ - 1
	else
		mpeg = 3
		if winglow < 14 then
			winglow = $ + 1
		end
	end
	if coop then
		v.draw(0, 0, winbg1, V_SNAPTOTOP|V_SNAPTOLEFT)
		if tokenpresent then
			v.drawString(38, 185, ("Getting ready for a special stage..."), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_REDMAP, "thin")
		elseif location == 1101 then
			v.drawString(38, 185, ("Logging results..."), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_REDMAP, "thin")
		elseif toend then
			v.drawString(38, 185, ("Complete."), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_REDMAP, "thin")
		elseif tocredits then
			v.drawString(38, 185, ("Initiating credits..."), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_REDMAP, "thin")
		elseif totitle then
			v.drawString(38, 185, ("Returning to title screen shortly..."), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_REDMAP, "thin")
		elseif location == 25 then
			v.drawString(38, 185, ("Getting ready..."), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_REDMAP, "thin")
		else
			v.drawString(38, 185, ("Getting ready for the next act..."), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_REDMAP, "thin")
		end
	else
		v.draw(0, 0, winbg2, V_SNAPTOTOP|V_SNAPTOLEFT)
		v.drawString(38, 185, ("Waiting for next round..."), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_REDMAP, "thin")
	end
	v.draw(0, 177, bar, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	if winglow > 0 and winglow < 14 then
		if winglow == 1 then v.draw(0, 177, flash1, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 2 then v.draw(0, 177, flash2, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 3 then v.draw(0, 177, flash3, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 4 then v.draw(0, 177, flash4, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 5 then v.draw(0, 177, flash5, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 6 then v.draw(0, 177, flash6, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 7 then v.draw(0, 177, flash7, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 8 then v.draw(0, 177, flash6, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 9 then v.draw(0, 177, flash5, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 10 then v.draw(0, 177, flash4, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 11 then v.draw(0, 177, flash3, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 12 then v.draw(0, 177, flash2, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif winglow == 13 then v.draw(0, 177, flash1, V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		end
	else
		winglow = 0
	end
end

local function WinLoad(v, player, ticker, endtime)
	if consoleplayer.mo and consoleplayer.mo.valid then
		local wininit = true
		if consoleplayer.mo.skin == "windows" and ((netgame and player.wintro) or (docustomintro and not netgame)) then
			if wininit then
				hud.disable("stagetitle")
				local window = v.cachePatch("WINLOAD")
				if ticker < endtime - TICRATE then
					v.draw(44, 73, window, V_SNAPTOTOP|V_PERPLAYER)
					if act != 0 then
						v.drawString(160, 148, mapname + " act " + act, V_SNAPTOTOP|V_PERPLAYER + actcolor, "center")
					else
						v.drawString(160, 148, mapname, V_SNAPTOTOP|V_PERPLAYER + actcolor, "center")
					end
				end
			end
		else
			if wininit then
				if not hud.enabled("stagetitle") then hud.enable("stagetitle") end
				wininit = false
			end
		end
	end
end

hud.add(WinTitle, "title")
hud.add(WinHUD, "game")
hud.add(WinLoad, "titlecard")
hud.add(WinInter, "intermission")